# DNS Lookup
# Part of Dolby
# I ripped this directly out of default.tcl

set dns_nicks ""

alias dns {
    set host [arg]
    if { [string match *.* $host] } {
        lookup $host
        echo "*** Attempting to resolve $host"
    } else {
        lappend dns_nicks [string tolower $host]
        whois $host
        echo "*** Retrieving information for $host"
    }
    complete
}

on lookup {
    set request [lindex [args] 0]
    set result  [lindex [args] 1]
    if { [string length $result] } {
        echo "*** Resolved $request to $result"
    } else {
        echo "[color error]*** ERROR: Could not resolve $request"
    }
}

on whois {
    set nick [string tolower [nick]]
    set i [lsearch $dns_nicks $nick]
    while { $i > -1 } {
        lookup [host]
        echo "*** Attempting to resolve [host]"
        set dns_nicks [lreplace $dns_nicks $i $i]
        set i [lsearch $dns_nicks $nick]
    }
}